c++-gtk-utils

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- File List
- File Members

Classes | Namespaces | Enumerations | Functions
shared_ptr.h File Reference
`#include <utility>`
`#include <exception>`
`#include <new>`
`#include <functional>`
`#include <cstddef>`
`#include <glib.h>`
`#include <c++-gtk-utils/cgu_config.h>`

Go to the source code of this file.

## Classes
class | Cgu::SharedPtrError< T >
| This is an exception struct thrown as an alternative to deleting a managed object when internal memory allocation for SharedPtr or SharedLockPtr fails in their reset() method or in their constructor which takes a pointer. More...
class | Cgu::SharedPtr< T >
| This is a smart pointer for managing the lifetime of objects allocated on freestore. More...
class | Cgu::SharedLockPtr< T >
| This is a smart pointer for managing the lifetime of objects allocated on freestore, with a thread safe reference count. More...

## Namespaces
namespace | Cgu
namespace | Cgu::SharedPtrAllocFail

## Enumerations
enum | Cgu::SharedPtrAllocFail::Leave { Cgu::SharedPtrAllocFail::leave }

## Functions
template<class T >
bool | Cgu::operator== (const SharedPtr< T > &s1, const SharedPtr< T > &s2)
template<class T >
bool | Cgu::operator!= (const SharedPtr< T > &s1, const SharedPtr< T > &s2)
template<class T >
bool | Cgu::operator< (const SharedPtr< T > &s1, const SharedPtr< T > &s2)
template<class T >
bool | Cgu::operator== (const SharedLockPtr< T > &s1, const SharedLockPtr< T > &s2)
template<class T >
bool | Cgu::operator!= (const SharedLockPtr< T > &s1, const SharedLockPtr< T > &s2)
template<class T >
bool | Cgu::operator< (const SharedLockPtr< T > &s1, const SharedLockPtr< T > &s2)